﻿(in-package :custom)
(use-package :oli)

(sd-defdialog 'tp_sd_vp_print_dia
:dialog-title "Drucken"
:toolbox-button nil
:after-initialization
	'(progn
		(tp_drucker_tab)
	);;ende progn
;:initial-variable 'tp_file
:variables '(
	(tp_drucker1
		:initial-visible t
		:value-type :String
		:show-input-tool
			(progn
				(sd-show-display-table "tp_drucker1_tab")
			)
		:hide-input-tool
			(progn
				(sd-hide-display-table "tp_drucker1_tab")
			)
		:title "Drucker"
		:after-input 
			(progn
			
			)
	)
	(tp_format
		:title "Blattformat"
   		:size :second
   		:expand-shrink ((tp_format))
   		:expand-shrink-range (
				("A4" :label "A4")
				("A3" :label "A3")
				("A2" :label "A2")
				("A1" :label "A1")
				("A0" :label "A0")
			);;ende range
	)
	
);;ende variables

:ok-action '(progn
					(tp_render_to_file)
				);;ende progn

:local-functions '(

;;=========================================================================================================================================================================================================================

(tp_render_to_file ()
	(if (string= tp_format "A0")
	(progn
		(setq tp_x 7022)
		(setq tp_y 4967)
	))
	(if (string= tp_format "A1")
	(progn
		(setq tp_x 4967)
		(setq tp_y 3508)
	))
	(if (string= tp_format "A2")
	(progn
		(setq tp_x 3508)
		(setq tp_y 2480)
	))
	(if (string= tp_format "A3")
	(progn
		(setq tp_x 2480)
		(setq tp_y 1754)
	))
	(if (string= tp_format "A4")
	(progn
		(setq tp_x 1754)
		(setq tp_y 1240)
	))

	(setq tp_x1 (gpnt2d_x (first (sd-inq-vp-corners (sd-inq-current-vp)))))
	(setq tp_y1 (gpnt2d_y (first (sd-inq-vp-corners (sd-inq-current-vp)))))
	(setq tp_x2 (gpnt2d_x (second (sd-inq-vp-corners (sd-inq-current-vp)))))
	(setq tp_y2 (gpnt2d_y (second (sd-inq-vp-corners (sd-inq-current-vp)))))
	
	(if (> tp_x2 tp_x1) (setq tp_x3 (- tp_x2 tp_x1)))
	(if (> tp_x1 tp_x2) (setq tp_x3 (- tp_x1 tp_x2)))
	(if (> tp_y2 tp_y1) (setq tp_y3 (- tp_y2 tp_y1)))
	(if (> tp_y1 tp_y2) (setq tp_y3 (- tp_y1 tp_y2)))
	
	(if (> tp_x3 tp_y3) (setq tp_fak (/ tp_x3 tp_y3)))
	(if (> tp_y3 tp_x3) (setq tp_fak (/ tp_y3 tp_x3)))

	(setq tp_path (concatenate 'string (sd-string-replace (sd-string-trim(sd-sys-getenv "POWERXTMP")) "\\" "/") "/tp_vp_dump.jpg"))
	(setq tp_arg (sd-string-replace tp_path  "/" "\\"))
	
	(sd-call-cmds (create_thumbnail
		:DESTINATION_FILE_TYPE :JPG
		:TRANSPARENT :ON
		:size_X tp_x
		:size_Y (round(/ tp_x tp_fak))
		:FILENAME tp_path
		:OVERWRITE
	))

	(setq tp_printer (sd-string-replace tp_drucker1 " " "_"))
	
	(setq tp_pfad (concatenate 'string "\"C:\\Mein Ordner\\LSP\\Eigene\\VP_Dump\\ImagePrint.exe\""))
	
	(sd-sys-exec (format nil "~A ~A ~A ~A" tp_pfad tp_arg tp_printer tp_format))
);;ende tp_render_to_file

;;=========================================================================================================================================================================================================================

(tp_drucker_tab ()
	(setq tp_drucker_tabelle '())
	(setq tp_drucker (getf (first(sd-execute-annotator-function :fnc "Docu_inq_plotters")) :MSWINDOW_GDI_PRINTER))
	

	(loop for x from 0 to (-(length tp_drucker)1) do
	(progn
		(setq tp_temp1 '())
		(setq tp_temp (first(nth x tp_drucker)))
		(setq tp_temp1 (cons tp_temp tp_temp1))
		(setq tp_drucker_tabelle (push tp_temp1 tp_drucker_tabelle))
	));;ende loop

	(sd-create-logical-table "tp_drucker1_tab"
		:columns     '	(:tp_drucker1)
		:columnNames '	("Drucker")
		:types       '	(:String)
		:units       '	(nil)
		:contents   tp_drucker_tabelle
	)
	(sd-create-display-table "tp_drucker1_tab"
		:tableTitle             "Windows Drucker"
		:logicalTable           "tp_drucker1_tab"
		:columns                '(:tp_drucker1)
		:applyColumns           '(:tp_drucker1)
		:selectionMode          :single-row       ;; :single-cell | :single-row | :multiple-rows 
		:applyAction            :default-tokens          ;; nil | :default | :default-tokens | LISP-form
		:bottomLine nil                           ;; :apply-close-help | :apply-custom-close-help | :help | nil
		:filterStatusLine       nil
;		:displayWidth	250
	);;sd-create-display-table
);;ende tp_drucker_tab

;;=========================================================================================================================================================================================================================



);; ende local functions
);;ende dialog